package com.company;


import java.util.Scanner;

public class Players {
    private int possibleMoves;

    public Players(){
        possibleMoves = 0;
    }

    public boolean containsInArray(int[][] arr, int x, int y){
        if (arr[x][y] != 0)
            return true;
        else
            return false;
    }

    public void searchInNeighbors(int[][] arrOpponent, int[][] arr, int x, int y){
        if (x != 1){
            if (containsInArray(arrOpponent, x - 1, y)){
                equalize(arrOpponent, arr, x, y, -1, 0);
            }
            if (y != 1){
                if (containsInArray(arrOpponent, x - 1, y - 1))
                    equalize(arrOpponent, arr, x, y, -1, -1);
            }
            if (y != 8){
                if (containsInArray(arrOpponent, x - 1, y + 1))
                    equalize(arrOpponent, arr, x, y, -1, +1);
            }
        }

        if (x != 8){
            if (containsInArray(arrOpponent, x + 1, y)){
                equalize(arrOpponent, arr, x, y, +1, 0);
            }
            if (y != 1){
                if (containsInArray(arrOpponent, x + 1, y - 1))
                    equalize(arrOpponent, arr, x, y, +1, -1);
            }
            if (y != 8){
                if (containsInArray(arrOpponent, x + 1, y + 1))
                    equalize(arrOpponent, arr, x, y, +1, +1);
            }
        }

        if (y != 1){
            if (containsInArray(arrOpponent, x, y - 1))
                equalize(arrOpponent, arr, x, y, 0, -1);
        }

        if (y != 8){
            if (containsInArray(arrOpponent, x, y + 1))
                equalize(arrOpponent, arr, x, y, 0, +1);
        }

    }

    public void display(int[][] a1, int[][] a2){
        System.out.println("  A  B C  D  E F  G H");
        for (int i = 1; i <= 8; i++){
            System.out.print(i+ " ");
            for (int j = 1; j <= 8; j++) {
                if (containsInArray(a2, j, i)) {
                    // the unicode of white circle *
                    System.out.print('\u25CB');
                }
                else {
                    if (containsInArray(a1, j, i)) {
                        // the unicode of black circle
                        System.out.print('\u26AB');
                    }
                    else
                        // the unicode of white square
                        System.out.print('\u2B1C');
                }
                System.out.print(" ");
            }
            System.out.println();
        }
    }

    public void equalize(int[][] arrOpponent, int[][]arr, int x, int y, int moveX, int moveY) {
        if (checkTheMoveIfPossible(arrOpponent, arr, x, y, moveX, moveY)) {
            arr[x][y] = 1;
            while (((x >= 1) && (x <= 8) && (y >= 1) && (y <= 8))
                    && (!containsInArray(arr, x + moveX, y + moveY))) {
                x += moveX;
                y += moveY;
                arr[x][y] = 1;
                arrOpponent[x][y] = 0;
            }
        }
    }

    public int numberOfPlayerPossibleMoves(int[][] arrOpponent, int[][]arr){
        for (int i = 1; i < 9; i++){
            for (int j = 1; j < 9; j++){
                if ((!containsInArray(arr, j, i)) && (!containsInArray(arrOpponent, j, i))){
                    //System.out.print(j);
                    //System.out.println(i);
                    if (checkSides(arrOpponent, arr, j, i)) {
                        //System.out.println("x ="+j+"y ="+i);
                        return 1;
                    }
                }
                /*else {
                    if (containsInArray(arr, j, i))
                        System.out.println("khoditrue");
                    else
                        System.out.println("khodifalse");
                    if (containsInArray(arrOpponent, j, i))
                        System.out.println("ghkhoditrue");
                    else
                        System.out.println("ghkhodifalse");
                }*/
            }
        }
        return possibleMoves;
    }

    public boolean checkSides(int[][] arrOpponent, int[][] arr, int x, int y){
        if (x != 1){
            if (containsInArray(arrOpponent, x - 1, y)){
                if (checkTheMoveIfPossible(arrOpponent, arr, x, y, -1, 0))
                    return true;
            }
            if (y != 1){
                if (containsInArray(arrOpponent, x - 1, y - 1))
                  if (checkTheMoveIfPossible(arrOpponent, arr, x, y, -1, -1))
                      return true;
            }
            if (y != 8){
                if (containsInArray(arrOpponent, x - 1, y + 1))
                    if (checkTheMoveIfPossible(arrOpponent, arr, x, y, -1, +1))
                        return true;
            }
        }
        if (x != 8){
            if (containsInArray(arrOpponent, x + 1, y)){
                if (checkTheMoveIfPossible(arrOpponent, arr, x, y, +1, 0))
                    return true;
            }
            if (y != 1){
                if (containsInArray(arrOpponent, x + 1, y - 1))
                    if (checkTheMoveIfPossible(arrOpponent, arr, x, y, +1, -1))
                        return true;
            }
            if (y != 8){
                if (containsInArray(arrOpponent, x + 1, y + 1)) {
                    if (checkTheMoveIfPossible(arrOpponent, arr, x, y, +1, +1))
                        return true;
                }
            }
        }
        if (y != 1){
            if (containsInArray(arrOpponent, x, y - 1))
                if (checkTheMoveIfPossible(arrOpponent, arr, x, y, 0, -1))
                    return true;
        }
        if (y != 8){
            if (containsInArray(arrOpponent, x, y + 1)) {

                if (checkTheMoveIfPossible(arrOpponent, arr, x, y, 0, +1))
                    return true;
            }
        }
        return false;
    }

    public boolean checkTheMoveIfPossible(int[][] arrOpponent, int[][]arr, int x, int y, int moveX, int moveY){
        int x1 = x; int y1 = y;
        x1 += moveX;
        y1 += moveY;
        while ((x1 > 0) && (x1 < 9) && (y1 > 0) && (y1 < 9)){
            if (containsInArray(arrOpponent, x1, y1)){
                x1 += moveX;
                y1 += moveY;
            }
            else{
                if (containsInArray(arr, x1, y1))
                    return true;
                else
                    break;
            }
        }
        return false;
    }

}
